Unit QST1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QST1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);

implementation

procedure QST1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);
var
C,D,G :Integer;
J,L,H,R,U :Real;
const
KMAX :Integer = 1048576;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
IERR := 0;
K := Abs(K);
if ( K  = 0 ) 
 then goto _12;
C := 0;
U := 0.0;
J := B-A;
H := F(A)+F(B);
_1:
L := J/K;
if ( C ) < 0
 then goto _4
 else if ( C ) > 0
       then goto _4
       else goto _2;
_2:
G := K-1;
if ( G  = 0 )
 then goto _4;
for D:=1 to G do
 begin
  U := U+F(A+D*L);
_3:
 end;
_4:
if ( C-1 ) < 0
 then goto _7
 else if ( C-1 ) > 0
       then goto _5
       else goto _5;
_5:
U := F(A+L);
G := (K-2) div 2;
if ( G  = 0 )
 then goto _7;
for D:=1 to G do
 begin
  U := U+F(A+(2*D+1)*L);
_6:
 end;
_7:
H := 2.0*U+H;
U := H*L/2.0;
if ( E ) < 0
 then goto _11
 else if ( E ) > 0
       then goto _8
       else goto _11;
_8:
C := C+1;
if ( C-1 ) < 0
 then goto _10
 else if ( C-1 ) > 0
       then goto _10
       else goto _9;
_9:
K := 2*K;
R := U;
if ( K  < KMAX ) 
 then goto _1;
IERR := 65;
K := KMAX;
UTQS10(IERR,2);
goto _12;
_10:
if ( Abs(U-R)-E ) < 0
 then goto _11
 else if ( Abs(U-R)-E ) > 0
       then goto _9
       else goto _11;
_11:
INT := U;
_12:
end;

end.
